/* Start ppp with dynamic ip addr. */

/* The default settings cause the host to always be   net_ip||"10"  and the user
   to be   net_ip||task+user_base  (eg for task 1, host_ip=129.0.0.10 and
   user_ip=127.0.0.31

   The task and com port are taken from the environment variables TASK and PORT.
*/

/* some default values */
env         ="OS2ENVIRONMENT"    /* where to get environment variables from       */
def_idle    =20                  /* default timeout for idle timer                */

defnetmask  =""                  /* your netmask - leave blank to not specify     */

net_host_ip ="203.15.133."       /* first 3 parts of your host ip address, with 3 */
                                 /* dots                                          */
net_user_ip ="203.15.133."       /* first 3 parts of the ip addresses you can     */
                                 /* assign to users.                              */

one_host_ip =1                   /* if non-zero, host_base is appended to net_ip
                                    and task is ignored. Has no effect on user IP */
host_base   =229                 /* add this to the task to get host IP           */
user_base   =232                 /* add this to the task to get user IP           */

netaddress  ="00:00:F7:4D:4D:92" /* use this network card address when creating ARP
                                    entry. Leave blank ("") to skip ARP entry.    */

parse arg speed ',' idle ',' host_ip ',' user_ip ',' netmask ',' otherparams

Say 'PPPHost : Port:'speed'  timeout:'idle'   IP addresses  'host_ip':'user_ip','netmask'  Other Options:'otherparams

etc=value('etc',,env)
username=value('user',,env)
fullname=value('FULL_NAME',,env)
port=value('port',,env)
task=value('task',,env)
if task='' then task=9
if netmask='' then netmsk=defnetmask

if idle='' then idle='idle '||def_idle
else if idle='0' then idle="" 
else idle='idle '||idle

host_ip=checkip(host_ip,net_host_ip,host_base,one_host_ip)
user_ip=checkip(user_ip,net_user_ip,user_base,0)
if netmask<>"" then netmask='netmask '||netmask

Say 'PPPHost : user is' fullname '"'username'" (UID='value('uid',,env)')'

tempfile='userinfo.'task
Call SysFileDelete(tempfile)
call lineout tempfile, fullname' ('username')'
call lineout tempfile, "On the 'net"
call lineout tempfile
Say 'Setting node 'task' status'
'@Echo off'
if task<>9 then '%max%\utils\ipc setinfo !\pipe\maximus\mcp-'task tempfile

/* output of PPP is directed to CON to make sure it doesn't interfere
   with the com port
*/

if netaddress<>"" then 'arp -s node'task+0' 'netaddress' pub'
/* Display the PPP settings */
Say '>PPP mru 1500 rtscts' host_ip':'user_ip netmask idle otherparams
'ppp com'port speed' mru 1500 rtscts' host_ip':'user_ip netmask 'modem reneg priority 1' otherparams idle 'exit >CON 2>CON'
if netaddress<>"" then 'arp -d node'task+0

return


checkip: procedure expose task
parse arg ip,net_ip,base,add_task

if ip="-"             then ip=""
else if ip=""         then do
                           if add_task=0 then ip=net_ip||base + task
                                         else ip=net_ip||base
                           end
else if pos(".",ip)=0 then ip=net_ip||ip
return ip

/***********************************************/
